
/*
 * Discrete Cosine Tansform (DCT) for subband synthesis
 *
 * -funroll-loops (for gcc) will remove the loops for better performance
 * using loops in the source-code enhances readabillity
 */

#include "mpg123.h"

void dct64(real *out,real *samples)
{
  real bufs[64];

 {
  register int i,j;
  register real *b1,*b2,*bs,*costab;

  b1 = samples;
  bs = bufs;
  costab = pnts[0]+16;
  b2 = b1 + 32;

  for(i=15;i>=0;i--)
    *bs++ = (*b1++ + *--b2); 
  for(i=15;i>=0;i--)
    *bs++ = (*--b2 - *b1++) * *--costab;

  b1 = bufs;
  costab = pnts[1]+8;
  b2 = b1 + 16;

  {
    for(i=7;i>=0;i--)
      *bs++ = (*b1++ + *--b2); 
    for(i=7;i>=0;i--)
      *bs++ = (*--b2 - *b1++) * *--costab; 
    b2 += 32;
    costab += 8;
    for(i=7;i>=0;i--)
      *bs++ = (*b1++ + *--b2); 
    for(i=7;i>=0;i--)
      *bs++ = (*b1++ - *--b2) * *--costab; 
    b2 += 32;
  }

  bs = bufs;
  costab = pnts[2];
  b2 = b1 + 8;

  for(j=2;j;j--)
  {
    for(i=3;i>=0;i--)
      *bs++ = (*b1++ + *--b2); 
    for(i=3;i>=0;i--)
      *bs++ = (*--b2 - *b1++) * costab[i]; 
    b2 += 16;
    for(i=3;i>=0;i--)
      *bs++ = (*b1++ + *--b2); 
    for(i=3;i>=0;i--)
      *bs++ = (*b1++ - *--b2) * costab[i]; 
    b2 += 16;
  }

  b1 = bufs;
  costab = pnts[3];
  b2 = b1 + 4;

  for(j=4;j;j--)
  {
    *bs++ = (*b1++ + *--b2); 
    *bs++ = (*b1++ + *--b2);
    *bs++ = (*--b2 - *b1++) * costab[1]; 
    *bs++ = (*--b2 - *b1++) * costab[0];
    b2 += 8;
    *bs++ = (*b1++ + *--b2); 
    *bs++ = (*b1++ + *--b2);
    *bs++ = (*b1++ - *--b2) * costab[1]; 
    *bs++ = (*b1++ - *--b2) * costab[0];
    b2 += 8;
  }
  bs = bufs;
  costab = pnts[4];
  b2 = b1 + 2;

  for(j=8;j;j--)
  {
    *bs++ = (*b1++ + *--b2);
    *bs++ = (*--b2 - *b1++) * (*costab);
    b2 += 4;
    *bs++ = (*b1++ + *--b2);
    *bs++ = (*b1++ - *--b2) * (*costab);
    b2 += 4;
  }

 }


 {
  register real *b1;
  register int i;

  for(b1=bufs,i=8;i;i--,b1+=4)
    b1[2] += b1[3];

  for(b1=bufs,i=4;i;i--,b1+=8)
  {
    b1[4] += b1[6];
    b1[6] += b1[5];
    b1[5] += b1[7];
  }

  for(b1=bufs,i=2;i;i--,b1+=16)
  {
    b1[8]  += b1[12];
    b1[12] += b1[10];
    b1[10] += b1[14];
    b1[14] += b1[9];
    b1[9]  += b1[13];
    b1[13] += b1[11];
    b1[11] += b1[15];
  }
 }

  out[0x8*31] = bufs[0];
  out[0x8*29] = bufs[8];
  out[0x8*27] = bufs[4];
  out[0x8*25] = bufs[12];
  out[0x8*23] = bufs[2];
  out[0x8*21] = bufs[10];
  out[0x8*19] = bufs[6];
  out[0x8*17] = bufs[14];
  out[0x8*15] = bufs[1];
  out[0x8*13] = bufs[9];
  out[0x8*11] = bufs[5];
  out[0x8* 9] = bufs[13];
  out[0x8* 7] = bufs[3];
  out[0x8* 5] = bufs[11];
  out[0x8* 3] = bufs[7];
  out[0x8* 1] = bufs[15];

  out[0x8*30] = bufs[16+0]  + bufs[16+8];
  out[0x8*28] = bufs[16+8]  + bufs[16+4];
  out[0x8*26] = bufs[16+4]  + bufs[16+12];
  out[0x8*24] = bufs[16+12] + bufs[16+2];
  out[0x8*22] = bufs[16+2]  + bufs[16+10];
  out[0x8*20] = bufs[16+10] + bufs[16+6];
  out[0x8*18] = bufs[16+6]  + bufs[16+14];
  out[0x8*16] = bufs[16+14] + bufs[16+1];
  out[0x8*14] = bufs[16+1]  + bufs[16+9];
  out[0x8*12] = bufs[16+9]  + bufs[16+5];
  out[0x8*10] = bufs[16+5]  + bufs[16+13];
  out[0x8* 8] = bufs[16+13] + bufs[16+3];
  out[0x8* 6] = bufs[16+3]  + bufs[16+11];
  out[0x8* 4] = bufs[16+11] + bufs[16+7];
  out[0x8* 2] = bufs[16+7]  + bufs[16+15];
  out[0x8* 0] = bufs[16+15];

}


